note
	description: "expanded_class application root class"
	date: "$Date$"
	revision: "$Revision$"

class
	TEST_EXPANDED_CLASS

inherit
	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- Run application.
		do
			add_boolean_case (agent test_expanded)
			show_browser
			run_espec
		end

feature -- Test queries
	test_expanded: BOOLEAN
		local
			eb1, eb2: B
		do
			-- We do not have to explicitly instantiate
			-- eb1 and eb2: they are created by default
			Result := eb1.i = 0 and eb2.i = 0
			check Result end

			-- Since eb1 and eb2 are expanded type,
			-- there is no notion of references/addresses
			-- so '=' here compares there contents
			Result := eb1 = eb2
			check Result end

			eb2.change_i (15)
			Result := eb1.i = 0 and eb2.i = 15
			check Result end

			Result := not (eb1 = eb2)
			check Result end

			-- Contents of eb2 copied over to eb1 (no aliasing)
			eb1 := eb2
			Result := eb1.i = 15 and eb2.i = 15
			check Result end

			Result := eb1 = eb2
			check Result end

			eb1.change_i (10)
			Result := eb1.i = 10 and eb2.i = 15
			check Result end

			Result := eb1 /= eb2 
		end

end
